Attribute VB_Name = "MainModule"
Option Explicit

Private Type varSendVar
    nm_variabel As String * 50
    val_variabel As String * 50
End Type

Private Type varip
    ip_variabel As String * 20
End Type

Public Conn As New ADODB.Connection
Public lcSource, Version, FormatA As String
Private Const GW_HWNDPREV = 3
Dim SendVar As varSendVar
    Public lcDatabase, lcUser_id, lcNm_menu As String


Declare Function FindWindow Lib "User32" Alias "FindWindowA" _
   (ByVal lpClassName As String, ByVal lpWindowName As String) _
   As Long
Declare Function GetWindow Lib "User32" _
   (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Private Declare Function ShowWindow Lib "user32.dll" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Declare Function SetForegroundWindow Lib "User32" _
   (ByVal hWnd As Long) As Long


Sub Main()
    Dim lcFind As Variant
    Dim SendVar As varSendVar
    Dim Server, Login, Password, Database, Driver As String
    Dim I, PosisiAkhir As Integer
    Dim IniFile As New INIClass
    lcSource = "W:\"
    FormatA = "#,##0"
      
    'Cek apakah Matari On-Line sudah di-load
    If App.PrevInstance = True Then
        ActivatePrevInstance
    End If

    Open "c:\Windows\temp\login.txt" For Random As #1 Len = Len(SendVar)
    PosisiAkhir = LOF(1) / Len(SendVar)
    For I = 1 To PosisiAkhir
        Get #1, I, SendVar
        If Trim(SendVar.nm_variabel) = "Database" Then
            lcDatabase = Trim(SendVar.val_variabel)
        End If
        If Trim(SendVar.nm_variabel) = "User_id" Then
            lcUser_id = Trim(SendVar.val_variabel)
        End If
        If Trim(SendVar.nm_variabel) = "NamaMenu" Then
            lcNm_menu = Trim(SendVar.val_variabel)
        End If
    Next I
    Close #1
    If lcUser_id = "" Then
        MsgBox "Cannot find User Id.", vbOKOnly + vbExclamation, "Error"
        End
    End If
    

    lcFind = Dir(App.Path & "\Clara.ini")
    If lcFind = "" Then
        IniFile.ProfileSaveItem "Server", "Version", "3", App.Path & "\Clara.ini"
        IniFile.ProfileSaveItem "Server", "ServerName", "localhost", App.Path & "\Clara.ini"
        IniFile.ProfileSaveItem "Server", "Database", "clara", App.Path & "\Clara.ini"
        IniFile.ProfileSaveItem "Server", "Login", "root", App.Path & "\Clara.ini"
        IniFile.ProfileSaveItem "Server", "Password", EncryptIt("none"), App.Path & "\Clara.ini"
    End If

    Version = IniFile.ProfileGetItem("Server", "Version", "3", App.Path & "\Clara.ini", 0)
    Server = IniFile.ProfileGetItem("Server", "ServerName", "localhost", App.Path & "\Clara.ini", 0)
    Database = IniFile.ProfileGetItem("Server", "Database", "clara", App.Path & "\Clara.ini", 0)
    Login = IniFile.ProfileGetItem("Server", "Login", "user", App.Path & "\Clara.ini", 0)
    Password = DecryptIt(IniFile.ProfileGetItem("Server", "Password", "user", App.Path & "\Clara.ini", 0))


    
    Conn.CommandTimeout = 0
    Conn.ConnectionTimeout = 0
    Conn.CursorLocation = adUseClient
'    Select Case Left(Version, 1)
'    Case 3
'        Driver = "mysql"
'    Case 4
        Driver = "{MySQL ODBC 3.51 Driver}"
'    End Select
    Conn.Open "driver=" & Driver & ";server=" & Server & ";database=" & Database & ";uid=" & Login & ";pwd=" & Password & "; "
    
    FrmTransaksiJurnal.Show
End Sub



Function fctFind(strsql As String, Conn As ADODB.Connection) As Variant
   'Find field or record in SQL
    Dim rstTmp As New ADODB.Recordset
    rstTmp.CursorLocation = adUseClient
    If rstTmp.State = adStateOpen Then rstTmp.Close
    rstTmp.Open strsql, Conn
    If Not rstTmp.EOF And Not rstTmp.BOF Then
        rstTmp.MoveFirst
    If IsNull(rstTmp(0)) = True Then fctFind = Empty Else fctFind = rstTmp(0)
        rstTmp.Close
    Else
        fctFind = Empty
    End If
    Set rstTmp = Nothing

End Function

Function ReleaseAll()
    Dim lcFind As Variant
    lcFind = Dir(App.Path & "\logmol.txt")
    If Not lcFind = "" Then Kill App.Path & "\logmol.txt"
End Function


'This Procedure/Sub will try to find for another instance of the program
'running and activate it
Public Sub ActivatePrevInstance()
   Dim OldTitle As String
   Dim PrevHndl As Long
   Dim result As Long

   'Save the title of the application.
   OldTitle = App.Title

   'Rename the title of this application so FindWindow
   'will not find this application instance.
   App.Title = "unwanted instance"

   'Attempt to get window handle using VB4 class name.
   PrevHndl = FindWindow("ThunderRTMain", OldTitle)

   'Check for no success.
   If PrevHndl = 0 Then
       'Attempt to get window handle using VB5 class name.
       PrevHndl = FindWindow("ThunderRT5Main", OldTitle)
   End If

   'Check if found
   If PrevHndl = 0 Then
       PrevHndl = FindWindow("ThunderRT6Main", OldTitle)
   End If

   'Check if found
   If PrevHndl = 0 Then
       'No previous instance found.
       Exit Sub
   End If

   'Get handle to previous window.
   PrevHndl = GetWindow(PrevHndl, GW_HWNDPREV)

   'Restore the program.
'   result = OpenIcon(PrevHndl)

   'Show the Window, I think we need this better than OpenIcon
   'Since sometimes we hide the program in systray
   result = ShowWindow(PrevHndl, vbNull)
   
   'Activate the previous application.
   result = SetForegroundWindow(PrevHndl)
   
    'End the current application.
   End
End Sub


'This function add another single quote to a query with odd number of single quote
'so that SQL don't identify it as a keyword
Public Function KillQuote(ByVal kata As String) As String
    KillQuote = Replace(Trim(kata), "'", "''", 1, Len(kata))
End Function


'Function to force that only numbers can be inserted, with or without commas and periods
Public Function angka_only(ByRef masukan As Integer, Optional ByVal With_commas As Boolean = False) As Integer
  ' kode Ascii 48 s/d 57 adalah angka 0 s/d 9
  ' kode Ascii 8 adalah BackSpace
  If With_commas Then
    If (masukan >= 48 And masukan <= 57) Or masukan = 8 Or masukan = 44 Or masukan = 46 Then
        angka_only = masukan
    Else
        angka_only = 0
    End If
  Else
  If (masukan >= 48 And masukan <= 57) Or masukan = 8 Then
    angka_only = masukan
  Else
    angka_only = 0
  End If
  End If
End Function


'This is cute function is design to replace the CStr() function.
'This function itself use CStr() in it but the result will prevent
'the conversion error generate when find the NULL value.
'Take a notice that this function will replace the NULL value to the "" (empty string) value.
'Check your VB help for it."
Function NullStr(varvalue As Variant) As String
  If IsNull(varvalue) Then NullStr = "" Else NullStr = CStr(varvalue)
End Function


'Left fill text until exceed the length of CodeLength with the PadChar character.
'Example: strText = StrLPad("1", "0", 5)
'         strText value wil be "00001"
'Beware: Use only one character string in PadChar!!!
Function StrLPad(StringSource As String, PadChar As String, CodeLength As Integer) As String
  Dim StrTmp As String
  StrTmp = StringSource
  While Len(StrTmp) < CodeLength
    StrTmp = PadChar + StrTmp
  Wend
  StrLPad = StrTmp
End Function


'Right fill text until exceed the length of CodeLength with the PadChar character.
'Example: strText = StrRPad("1", "X", 5)
'         strText value wil be "1XXXX"
'Beware: Use only one character string in PadChar!!!
Function StrRPad(StringSource As String, PadChar As String, CodeLength As Integer) As String
  Dim StrTmp As String
  StrTmp = StringSource
  While Len(StrTmp) < CodeLength
    StrTmp = StrTmp + PadChar
  Wend
  StrRPad = StrTmp
End Function


Function DecryptIt(sPassword As String) As String
  Dim PrivKey As Integer, ModRes As Integer, A As Integer
  DecryptIt = ""
  PrivKey = Len(sPassword)
  For A = 1 To PrivKey
    ModRes = A Mod 2
    If ModRes = 0 Then
      DecryptIt = DecryptIt + Chr(Asc(Mid$(sPassword, A, 1)) - PrivKey)
    Else
      DecryptIt = DecryptIt + Chr(Asc(Mid$(sPassword, A, 1)) + PrivKey)
    End If
  Next A
End Function

Function EncryptIt(sPassword As String) As String
  Dim PrivKey As Integer, ModRes As Integer, A As Integer
  EncryptIt = ""
  PrivKey = Len(sPassword)
  For A = 1 To PrivKey
    ModRes = A Mod 2
    If ModRes = 0 Then
      EncryptIt = EncryptIt + Chr(Asc(Mid$(sPassword, A, 1)) + PrivKey)
    Else
      EncryptIt = EncryptIt + Chr(Asc(Mid$(sPassword, A, 1)) - PrivKey)
    End If
  Next A
End Function


Public Function bFileExists(sFileName As String) As Boolean
    'This function checks for the existance
    '     of a file
    Dim fs As Object
    'Set fs to File System Object
    Set fs = CreateObject("Scripting.FileSystemObject")
    
    'Check to see if file sFilename exists
    bFileExists = fs.FileExists(sFileName)
    Set fs = Nothing
End Function
